-------------------------------------------------------------------
--                    RANDOM DISASTERS MOD                       --
--                            V 1.2                              --
--                                                               --
--                       By Kostyan1996                          --
-------------------------------------------------------------------



                         ---VARIABLES---

admin_usgn = 13223	-- USGN of admin.
time_until = 1		-- 1 if you want to see time until next DISASTER and 0 if you not.
tile_spawn1 = 0		-- 1 if you want to NPCs and buildings spawn on death tiles and obstacles.
min_dis = 3  		-- every x minutes (in this case - 3) will happen RANDOM DISASTER.
stuff_amount = 50		-- amount of stuff (NPCs, buildings, explosions and all other), which will spawn on the map
				-- (smaller number - less amount and vice versa).
stuff_time = 5		-- x seconds (in this case - 5) will happening RANDOM DISASTER.
menu_key = 2		-- Fx (in this case - 2 (F2)) will call admin menu.


                            ---~~~---












                            ---HOOKS---

addhook("second","rand_dis")
addhook("serveraction","admin_menu_stop")
addhook("menu","admin_menu_choose")

                            ---~~~---

time_stop = 0
dis = 0
dis1 = 0
dis2 = 0
dis3 = 0
dis4 = 0
dis5 = 0
time_sec = min_dis*60
time_min = 0
size_xx = map("xsize")
size_yy = map("ysize")
on_off_time = "Stop time"
hid_but = 0
hid_but1 = 0
hid_but2 = 0
hid_but3 = 0
hid_but4 = 0
hid_but5 = 0

                       ---ZOMBOPOCALYPSE---

function zombopocalypse()
	zombo_amount = (size_xx*size_yy)/stuff_time/(1000/stuff_amount)
	for i=1,zombo_amount do
		zombo_x = math.random(1,size_xx-1)
		zombo_y = math.random(1,size_yy-1)
		zombo_rotate = math.random(0,360)
		zombotype = math.random(0,5)
		if zombotype == 0 or zombotype == 1 or zombotype == 2 or zombotype == 3 or zombotype == 4 then
			zombo_type = 1
		end
		if zombotype == 5 then
			zombo_type = 5
		end
		if (tile_spawn1 == 0) then
			if (tile(zombo_x,zombo_y,"wall") == false) and (tile(zombo_x,zombo_y,"obstacle") == false) and (tile(zombo_x,zombo_y,"deadly") == false) then
				parse('spawnnpc '..zombo_type..' '..zombo_x..' '..zombo_y..' '..zombo_rotate)
			else
				zombo_amount = zombo_amount + 1
			end
		else
			parse('spawnnpc '..zombo_type..' '..zombo_x..' '..zombo_y..' '..zombo_rotate)
		end
	end
	rand_dis1 = 0
end

                            ---~~~---

                       ---ALIEN INVADE---

function alieninvade()
	alien_amount = (size_xx*size_yy)/stuff_time/(1000/stuff_amount)
	for i=1,alien_amount do
		alien_x = math.random(1,size_xx-1)
		alien_y = math.random(1,size_yy-1)
		alien_rotate = math.random(0,360)
		alientype = math.random(0,5)
		if alientype == 0 or alientype == 1 or alientype == 2 then
			alien_type = 2
		end
		if alientype == 3 or alientype == 4 then
			alien_type = 3
		end
		if alientype == 5 then
			alien_type = 4
		end
		if (tile_spawn1 == 0) then
			if (tile(alien_x,alien_y,"wall") == false) and (tile(alien_x,alien_y,"obstacle") == false) and (tile(alien_x,alien_y,"deadly") == false) then
				parse('spawnnpc '..alien_type..' '..alien_x..' '..alien_y..' '..alien_rotate)
			else
				alien_amount = alien_amount + 1
			end
		else
			parse('spawnnpc '..alien_type..' '..alien_x..' '..alien_y..' '..alien_rotate)
		end
	end
	rand_dis1 = 0
end

                            ---~~~---
	
                       ---EXPLODE MASSACRE---

function explodemassacre()
	expl_amount = (size_xx*size_yy)/stuff_time/(1000/stuff_amount)
	for i=1,expl_amount do
		expl_x = math.random(1,size_xx-1)*32
		expl_y = math.random(1,size_yy-1)*32
		expl_size = math.random(50,200)
		expl_damage = math.random(50,100)
		if (tile_spawn1 == 0) then
			if (tile(expl_x,expl_y,"wall") == false) and (tile(expl_x,expl_y,"obstacle") == false) and (tile(expl_x,expl_y,"deadly") == false) then
				parse('explosion '..expl_x..' '..expl_y..' '..expl_size..' '..expl_damage)
			else
				expl_amount = expl_amount + 1
			end
		else
			parse('explosion '..expl_x..' '..expl_y..' '..expl_size..' '..expl_damage)
		end
	end
	rand_dis1 = 0
end

                            ---~~~---

                    ---BUILDING CONSPIRACY---

function buildingconspiracy()
	build_amount = (size_xx*size_yy)/stuff_time/(1000/stuff_amount)
	for i=1,build_amount do
		build_x = math.random(1,size_xx-1)
		build_y = math.random(1,size_yy-1)
		buildtype = math.random(0,38)
		if buildtype == 0 or buildtype == 1 or buildtype == 2 or buildtype == 3 or buildtype == 4 or buildtype == 5 then
			build_type = 1
		end
		if buildtype == 6 or buildtype == 7 or buildtype == 8 or buildtype == 9 or buildtype == 10 or buildtype == 11 then
			build_type = 2
		end
		if buildtype == 12 or buildtype == 13 or buildtype == 14 or buildtype == 15 or buildtype == 16 then
			build_type = 3
		end
		if buildtype == 17 or buildtype == 18 or buildtype == 19 or buildtype == 20 then
			build_type = 4
		end
		if buildtype == 21 then
			build_type = 5
		end
		if buildtype == 22 or buildtype == 23 or buildtype == 24 or buildtype == 25 then
			build_type = 6
		end
		if buildtype == 26 or buildtype == 27 or buildtype == 28 then
			build_type = 7
		end
		if buildtype == 29 or buildtype == 30 or buildtype == 31 then
			build_type = 8
		end
		if buildtype == 32 or buildtype == 33 then
			build_type = 11
		end
		if buildtype == 34 then
			build_type = 12
		end
		if buildtype == 35 or buildtype == 36 or buildtype == 37 or buildtype == 38 then
			build_type = 20
		end
		if (tile_spawn1 == 0) then
			if (tile(build_x,build_y,"wall") == false) and (tile(build_x,build_y,"obstacle") == false) and (tile(build_x,build_y,"deadly") == false) then
				parse('spawnobject '..build_type..' '..build_x..' '..build_y..' 0 0 0 0')
			else
				build_amount = build_amount + 1
			end
		else
			parse('spawnobject '..build_type..' '..build_x..' '..build_y..' 0 0 0 0')
		end
	end
	rand_dis1 = 0
end

                            ---~~~---

                       ---NUTHOUSE OF TELEPORTING---

function nuthouseofteleporting()
	for i=1,32 do
		tppl_x = math.random(1,size_xx-1)*32
		tppl_y = math.random(1,size_yy-1)*32
		if (tile_spawn1 == 0) then
			if (tile(tppl_x,tppl_y,"wall") == false) and (tile(tppl_x,tppl_y,"obstacle") == false) and (tile(tppl_x,tppl_y,"deadly") == false) then
				parse('setpos '..i..' '..tppl_x..' '..tppl_y)
			else
				i = i - 1
			end
		else
			parse('setpos '..i..' '..tppl_x..' '..tppl_y)
		end
	end
	rand_dis1 = 0
end

                            ---~~~---

                      ---RANDOM DISASTERS AND TIME---

function rand_dis()
	if time_sec >= 60 then
		while time_sec >= 60 do
			time_sec = time_sec - 60
			time_min = time_min + 1
		end
	end
	if time_stop == 0 then
		if (time_sec > 0) and (time_min >= 0) then
			time_sec = time_sec - 1
		elseif (time_sec <= 0) and (time_min > 0) then
			time_sec = 59
			time_min = time_min - 1
		else
			dis = 1
		end
	end
	if time_until == 1 then
		if time_min < 10 then
			if time_sec < 10 then
				parse('hudtxt 1 "255255000TIME TO THE NEXT DISASTER:" 10 116')
				parse('hudtxt 2 "255000000 0'..time_min..':0'..time_sec..'" 202 116')
				parse('hudtxt 3 "255255000." 240 116')
			else
				parse('hudtxt 1 "255255000TIME TO THE NEXT DISASTER:" 10 116')
				parse('hudtxt 2 "255000000 0'..time_min..':'..time_sec..'" 202 116')
				parse('hudtxt 3 "255255000." 240 116')
			end
		else
			if time_sec < 10 then
				parse('hudtxt 1 "255255000TIME TO THE NEXT DISASTER:" 10 116')
				parse('hudtxt 2 "255000000 '..time_min..':0'..time_sec..'" 202 116')
				parse('hudtxt 3 "255255000." 240 116')
			else
				parse('hudtxt 1 "255255000TIME TO THE NEXT DISASTER:" 10 116')
				parse('hudtxt 2 "255000000 '..time_min..':'..time_sec..'" 202 116')
				parse('hudtxt 3 "255255000." 240 116')
			end
		end
	end

	if dis == 1 then
		rand_dis1 = math.random(1,5)
		if rand_dis1 == 1 then
			zombopocalypse1 = 1
			msg('255000000ZOMBOPOCALYPSE!@C')
		elseif rand_dis1 == 2 then
			alieninvade1 = 1
			msg('255000000ALIEN INVADE!@C')
		elseif rand_dis1 == 3 then
			explodemassacre1 = 1
			msg('255000000EXPLODE MASSACRE!@C')
		elseif rand_dis1 == 4 then
			buildingconspiracy1 = 1
			msg('255000000BUILDING CONSPIRACY!@C')
		elseif rand_dis1 == 5 then
			nuthouseofteleporting1 = 1
			msg('255000000NUTHOUSE OF TELEPORTING!@C')
		end
	dis = 0
	end
	if zombopocalypse1 == 1 then
		if dis1 < stuff_time then
			dis1 = dis1 + 1
			zombopocalypse()
			time_stop = 1
			hid_but = 1
			hid_but1 = 1
		else
			dis1 = 0
			zombopocalypse1 = 0
			time_sec = 0
			time_min = 0
			time_sec = min_dis*60
			if (on_off_time == "Stop time") then
				time_stop = 0
			end
			hid_but = 0
			hid_but1 = 0
		end
	end
	if alieninvade1 == 1 then
		if dis2 < stuff_time then
			dis2 = dis2 + 1
			alieninvade()
			time_stop = 1
			hid_but = 1
			hid_but2 = 1
		else
			dis2 = 0
			alieninvade1 = 0
			time_sec = 0
			time_min = 0
			time_sec = min_dis*60
			if (on_off_time == "Stop time") then
				time_stop = 0
			end
			hid_but = 0
			hid_but2 = 0
		end
	end
	if explodemassacre1 == 1 then
		if dis3 < stuff_time then
			dis3 = dis3 + 1
			explodemassacre()
			time_stop = 1
			hid_but = 1
			hid_but3 = 1
		else
			dis3 = 0
			explodemassacre1 = 0
			time_sec = 0
			time_min = 0
			time_sec = min_dis*60
			if (on_off_time == "Stop time") then
				time_stop = 0
			end
			hid_but = 0
			hid_but3 = 0
		end
	end
	if buildingconspiracy1 == 1 then
		if dis4 < stuff_time then
			dis4 = dis4 + 1
			buildingconspiracy()
			time_stop = 1
			hid_but = 1
			hid_but4 = 1
		else
			dis4 = 0
			buildingconspiracy1 = 0
			time_sec = 0
			time_min = 0
			time_sec = min_dis*60
			if (on_off_time == "Stop time") then
				time_stop = 0
			end
			hid_but = 0
			hid_but4 = 0
		end
	end
	if nuthouseofteleporting1 == 1 then
		if dis5 < stuff_time then
			dis5 = dis5 + 1
			nuthouseofteleporting()
			time_stop = 1
			hid_but = 1
			hid_but5 = 1
		else
			dis5 = 0
			nuthouseofteleporting1 = 0
			time_sec = 0
			time_min = 0
			time_sec = min_dis*60
			if (on_off_time == "Stop time") then
				time_stop = 0
			end
			hid_but = 0
			hid_but5 = 0
		end
	end
end

                            ---~~~---

                        ---ADMIN MENU---

function callmainmenu(id)
	if hid_but == 1 then
		left_sc = "("
		right_sc = ")"
	else
		left_sc = ""
		right_sc = ""
	end
	menu(id,"Choose option,"..on_off_time..","..left_sc.."Skip to disaster immediately"..right_sc..",Choose disaster")
end

function callchoosemenu(id)
	if hid_but1 == 1 then
		left_sc1 = "("
		right_sc1 = ")"
	else
		left_sc1 = ""
		right_sc1 = ""
	end
	if hid_but2 == 1 then
		left_sc2 = "("
		right_sc2 = ")"
	else
		left_sc2 = ""
		right_sc2 = ""
	end
	if hid_but3 == 1 then
		left_sc3 = "("
		right_sc3 = ")"
	else
		left_sc3 = ""
		right_sc3 = ""
	end
	if hid_but4 == 1 then
		left_sc4 = "("
		right_sc4 = ")"
	else
		left_sc4 = ""
		right_sc4 = ""
	end
	if hid_but5 == 1 then
		left_sc5 = "("
		right_sc5 = ")"
	else
		left_sc5 = ""
		right_sc5 = ""
	end
	menu(id,"Choose disaster,"..left_sc1.."ZOMBOPOCALYPSE"..right_sc1..","..left_sc2.."ALIEN INVADE"..right_sc2..","..left_sc3.."EXPLODE MASSACRE"..right_sc3..","..left_sc4.."BUILDING CONSPIRACY"..right_sc4..","..left_sc5.."NUTHOUSE OF TELEPORTING"..right_sc5..",<= Back")
end

function admin_menu_stop(id,menu_key1)
	if player(id,"usgn") == admin_usgn then
		if (menu_key1 == menu_key - 1) then
			callmainmenu(id)
		end
	end
end

function admin_menu_choose(id,menu_title,menu_num)
	if (menu_title == "Choose option") then
		if (menu_num == 1) then
			if (on_off_time == "Stop time") then
				time_stop = 1
				on_off_time = "Launch time"
				callmainmenu(id)
			else
				time_stop = 0
				on_off_time = "Stop time"
				callmainmenu(id)
			end
		elseif (menu_num == 2) then
			callmainmenu(id)
			if hid_but == 0 then
				dis = 1
			end
		elseif (menu_num == 3) then
			callchoosemenu(id)
		end
	end
	if (menu_title == "Choose disaster") then
		if (menu_num == 1) then
			callchoosemenu(id)
			if hid_but1 == 0 then
				zombopocalypse1 = 1
				msg('255000000ZOMBOPOCALYPSE!@C')
			end
		end
		if (menu_num == 2) then
			callchoosemenu(id)
			if hid_but2 == 0 then
				alieninvade1 = 1
				msg('255000000ALIEN INVADE!@C')
			end
		end
		if (menu_num == 3) then
			callchoosemenu(id)
			if hid_but3 == 0 then
				explodemassacre1 = 1
				msg('255000000EXPLODE MASSACRE!@C')
			end
		end
		if (menu_num == 4) then
			callchoosemenu(id)
			if hid_but4 == 0 then
				buildingconspiracy1 = 1
				msg('255000000BUILDING CONSPIRACY!@C')
			end
		end
		if (menu_num == 5) then
			callchoosemenu(id)
			if hid_but5 == 0 then
				nuthouseofteleporting1 = 1
				msg('255000000NUTHOUSE OF TELEPORTING!@C')
			end
		end
		if (menu_num == 6) then
			callmainmenu(id)
		end
	end
end

                            ---~~~---